	// ===============================================================
	// Global Var
	// ===============================================================
	
	// Edit Handler
	// _______________________________________________________________________
	var EDIT_HANDLER = function(){};	
	EDIT_HANDLER.REF_IS_MODIFIED = false;
	EDIT_HANDLER.HAS_NEWLY_SAVED_DATA = false;
	var PROPERTY_PARENT_ID = 0;
	var PROPERTY_PARENT_DESCRIPTION = "";
	
	
	// Cache
	// _______________________________________________________________________
	var PROPERTY_CAT_STOCKFLOW_ID = -1;
	var PROPERTY_EDIT_MODE = false;
	var PROPERTY_EDIT_ROW_INDEX = -1;
	var INPUT_INSTANCE = null;
	
	
	// Buttons [Optional]
	// _______________________________________________________________________
	var ADD_BBI = null;
	var SAVE_BBI = null;
	var DELETE_BBI = null;
	var CANCEL_BBI = null;
	var NAVIGATION_BACK_BBI = null;
	
	var LOAD_MORE_BBI = null;
	var LOAD_PREV_BBI = null;
	var LOAD_NEXT_BBI = null;
	var LOAD_PAGING_CMB = null;
	var LOAD_PAGING_IGNORE_NEXT_REQUEST = false;
	
	var SEARCH_CMD = null;
	var PRINT_BBI = null;
	var EXPORT_BBI = null;
	
	
	// Dialog Controls [Optional]
	// _______________________________________________________________________
	var CAT_STOCKFLOW_DESCRIPTION_TXT = null;
	var CAT_STOCKFLOW_IS_IN_CMB = null;
	var CAT_STOCKFLOW_IS_MONITORED_TXT = null;
	var CAT_STOCKFLOW_STATUS_CMB = null;
	
	
	var PARAM_CAT_STOCKFLOW_ID_FILE_FP = null;
	
	
	// DGV Controls
	// _______________________________________________________________________
	var STOCKFLOW_DGV = null;
	var STOCKFLOW_LAST_GET_MAP_ARRAY = null;


	// ===============================================================
	// Initialize Controls
	// ===============================================================     
	function FORM_INITIALIZE()
	{
		// Load Cache Parent Data [Add Redirects if this is a required data.]
		// ...........................................
		if(JSVC_COOKIE.VAR_ISSET("PROPERTY_PARENT_ID_STOCKFLOW"))
		{
			PROPERTY_PARENT_ID = JSVC_COOKIE.VAR_READ("PROPERTY_PARENT_ID_STOCKFLOW");
		}	
		else
		{
			//window.location = JSCUS_CACHE.AUTH_REDIRECT_URL[JSCUS_CACHE.LOGIN_CLASS];
			//window.close();
		}
		if(JSVC_COOKIE.VAR_ISSET("PROPERTY_PARENT_DESCRIPTION_STOCKFLOW"))
		{
			PROPERTY_PARENT_DESCRIPTION = JSVC_COOKIE.VAR_READ("PROPERTY_PARENT_DESCRIPTION_STOCKFLOW");
			if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("PAGE_PARENT_DESCRIPTION_TXT") == true)
			{
				JSOC_ELEMENT.VAR_VALUE("PAGE_PARENT_DESCRIPTION_TXT", PROPERTY_PARENT_DESCRIPTION);			
			}
			if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("PAGE_PARENT_DESCRIPTION_LBL") == true)
			{
				JSOC_ELEMENT.VAR_VALUE("PAGE_PARENT_DESCRIPTION_LBL", PROPERTY_PARENT_DESCRIPTION);			
			}
			if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("PAGE_TITLE_LBL") == true)
			{
				JSOC_ELEMENT.VAR_VALUE("PAGE_TITLE_LBL", JSOC_ELEMENT.VAR_VALUE("PAGE_TITLE_LBL") + " : " + PROPERTY_PARENT_DESCRIPTION);	
			}
		}	
		else
		{
			//window.location = JSCUS_CACHE.AUTH_REDIRECT_URL[JSCUS_CACHE.LOGIN_CLASS];	
		}
	
		// Restore Cache on reload
		// ...........................................	
		if
		(
			JSVC_COOKIE.VAR_ISSET("PROPERTY_PARENT_ID_STOCKFLOW") || 
			JSVC_COOKIE.VAR_ISSET("PROPERTY_PARENT_DESCRIPTION_STOCKFLOW")
		)
		{
			  window.onbeforeunload = function(event)
			  {
					// Get Current Root path
					var CURRENT_ROOT_PATH = JSCUS_CACHE.ROOT_PATH + JSVC_STR.VAR_MID(JSVC_STR.VAR_DLEFT(JSCUS_CACHE.AUTH_REDIRECT_URL[JSCUS_CACHE.LOGIN_CLASS], JSCUS_CACHE.SERVER_URL.length), 1, 1);
				
					// Cache Primary Key
					JSVC_COOKIE.VAR_ADD
					(
						'PROPERTY_PARENT_ID_STOCKFLOW', 
						PROPERTY_PARENT_ID, 
						5, 
						CURRENT_ROOT_PATH
					);
					
					// Cache Description
					JSVC_COOKIE.VAR_ADD
					(
						'PROPERTY_PARENT_DESCRIPTION_STOCKFLOW', 
						PROPERTY_PARENT_DESCRIPTION, 
						5, 
						CURRENT_ROOT_PATH
					);
			  };
		}
		
		// Assign Fixed Parent (Must remove auto-populate at ch.js and HTTP_PARENT_LOAD at eh.js)
		// ...........................................
		/*
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("PARENT_SELECT_CMB"))
		{
			JSOC_CMB.VAR_ADD
			(
				"PARENT_SELECT_CMB", 
				PROPERTY_PARENT_ID,
				PROPERTY_PARENT_DESCRIPTION
			);
		}
		*/
		
		
 		// Cache Class Properties
		// ...........................................
		if(JSVC_COOKIE.VAR_ISSET("PROPERTY_CAT_STOCKFLOW_ID"))
		{
			PROPERTY_CAT_STOCKFLOW_ID = JSVC_COOKIE.VAR_READ("PROPERTY_CAT_STOCKFLOW_ID");
		}	
		if(JSVC_COOKIE.VAR_ISSET("PROPERTY_EDIT_MODE"))
		{
			PROPERTY_EDIT_MODE = JSVC_COOKIE.VAR_READ("PROPERTY_CAT_STOCKFLOW_ID");
		}
	
		// Initialize: Modals
		// ...........................................
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("STOCKFLOW_MODAL") == true)
		{
			// Display Modal
			JSOC_DIALOG.VAR_MODAL("STOCKFLOW_MODAL", false);
		}
				
		// Initialize: Ribbon Buttons [Add Item]
		// ...........................................
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("ADD_BBI"))
		{
    		ADD_BBI = JSOC_ELEMENT.VAR_GET("ADD_BBI");     	
			
			// Add OnClick event [Show Modal]
			if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("STOCKFLOW_MODAL"))
			{
				ADD_BBI.onclick = 
					function()
					{		
						// Display Modal
						PROPERTY_CAT_STOCKFLOW_ID = FLAG_BIGINT_NULL;
						PROPERTY_EDIT_ROW_INDEX = -1;
						
						if(JSVC_VAR.VAR_ISSET(INPUT_INSTANCE))
						{
							JSOC_WINDOW.VAR_INPUT_INSTANCE_RESTORE(INPUT_INSTANCE);
						}
						EDIT_HANDLER.REF_IS_MODIFIED = true;
						JSOC_DIALOG.VAR_MODAL("STOCKFLOW_MODAL", true);
					};					
			}
			// Add OnClick event [Show Add/Edit Page]
			else
			{
				
			}
		}	
		
		// Initialize: Ribbon Buttons [Save Changes]
		// ...........................................
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SAVE_BBI"))
		{
    		SAVE_BBI = JSOC_ELEMENT.VAR_GET("SAVE_BBI");     
			if(JSVC_VAR.VAR_ISSET(HTTP_SAVE))
			{
				// Prepare Save callback
				var CALLBACK_HANDLER = 
					function(IS_SUCCESS)
					{
						// Abort on failure
						if(IS_SUCCESS == false)
						{
							return;
						}
					
						// Show record saved messageBox
						JSVC_INFO.VAR_RECORD_SAVED('');
					};
				
				// Add OnClick event
				SAVE_BBI.onclick = 
					function()
					{
						HTTP_SAVE(CALLBACK_HANDLER);
					};
			}
		}
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("CANCEL_BBI"))
		{
    		CANCEL_BBI = JSOC_ELEMENT.VAR_GET("CANCEL_BBI");      		
		}
		
		// Initialize: Ribbon Buttons [Add Back Link (to parent page)]
		// ...........................................
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("NAVIGATION_BACK_BBI"))
		{
    		NAVIGATION_BACK_BBI = JSOC_ELEMENT.VAR_GET("NAVIGATION_BACK_BBI");  
			
			// Add OnClick event
			NAVIGATION_BACK_BBI.onclick = 
				function()
				{
				};
		}
		
		// Initialize: Ribbon Buttons [Add Forward Link (to child page)]
		// ...........................................
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("NAVIGATION_BACK_BBI"))
		{
    		NAVIGATION_BACK_BBI = JSOC_ELEMENT.VAR_GET("NAVIGATION_BACK_BBI");  
			
			// Add OnClick event
			NAVIGATION_BACK_BBI.onclick = 
				function()
				{
				};	
		}
		
		// Initialize: Load more items to the list
		// ...........................................
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("LOAD_MORE_BBI"))
		{
    		LOAD_MORE_BBI = JSOC_ELEMENT.VAR_GET("LOAD_MORE_BBI");  
			LOAD_MORE_BBI.onclick = 
				function()
				{
					HTTP_SEARCH_LOAD_MORE();
				};
		}
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("LOAD_PREV_BBI"))
		{
    		LOAD_PREV_BBI = JSOC_ELEMENT.VAR_GET("LOAD_PREV_BBI");  
			LOAD_PREV_BBI.onclick = 
				function()
				{
					var CURRENT_INDEX = JSOC_CMB.VAR_SELECTED_INDEX(LOAD_PAGING_CMB);
					if(CURRENT_INDEX > 0)
					{
						JSOC_CMB.VAR_SELECTED_INDEX(LOAD_PAGING_CMB, CURRENT_INDEX - 1);
						LOAD_PAGING_CMB.onchange();
					}
				};
		}		
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("LOAD_NEXT_BBI"))
		{
    		LOAD_NEXT_BBI = JSOC_ELEMENT.VAR_GET("LOAD_NEXT_BBI");  
			LOAD_NEXT_BBI.onclick = 
				function()
				{
					var CURRENT_INDEX = JSOC_CMB.VAR_SELECTED_INDEX(LOAD_PAGING_CMB);
					if(CURRENT_INDEX + 1 < JSOC_CMB.VAR_COUNT(LOAD_PAGING_CMB))
					{
						JSOC_CMB.VAR_SELECTED_INDEX(LOAD_PAGING_CMB, CURRENT_INDEX + 1);
						LOAD_PAGING_CMB.onchange();
					}
				};
		}		
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("LOAD_PAGING_CMB"))
		{
    		LOAD_PAGING_CMB = JSOC_ELEMENT.VAR_GET("LOAD_PAGING_CMB");  
			LOAD_PAGING_CMB.onchange = 
				function()
				{
					HTTP_SEARCH_LOAD_PAGE();
				};
		}

		// Initialize: Ribbon Buttons [Add Search]
		// ...........................................
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_CMD"))
		{
			SEARCH_CMD = JSOC_ELEMENT.VAR_GET("SEARCH_CMD");
			SEARCH_CMD.onclick = function(){HTTP_SEARCH();};
		}		

		// Initialize: Ribbon Buttons [Add Print]
		// ...........................................
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("PRINT_BBI"))
		{
			PRINT_BBI = JSOC_ELEMENT.VAR_GET("PRINT_BBI");
			PRINT_BBI.onclick = function()
			{
				window.print();
			};
		}		
		
		// Initialize: Ribbon Buttons [Add Search]
		// ...........................................
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("EXPORT_BBI"))
		{
			EXPORT_BBI = JSOC_ELEMENT.VAR_GET("EXPORT_BBI");
			EXPORT_BBI.onclick = function()
			{
				JSOC_DIALOG.VAR_LOADING_SPINNER(true);
				JSRC_THREAD.REF_POST_DELAYED			
				(
					async function()
					{
						await JSRC_EXCEL.REF_EXPORT('STOCKFLOW_DGV');
						CUS_SEND_DIALOG_TRY_DISMISS();
					},
					100
				);
			};
		}		

		
		// Prepare onChange event
		// ...........................................
		var ON_CHANGE_EVENT = '';
		
		
		// Initialize: Input Controls
		// ...........................................
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("CAT_STOCKFLOW_ID_TXT"))
		{
			CAT_STOCKFLOW_ID_TXT = JSOC_ELEMENT.VAR_GET("CAT_STOCKFLOW_ID_TXT");      
			CAT_STOCKFLOW_ID_TXT.onchange = 
				function()
				{
					if(CAT_STOCKFLOW_ID_TXT.disabled == false)
					{
						EDIT_HANDLER.REF_IS_MODIFIED = true;
					}
				};
			CAT_STOCKFLOW_ID_TXT.onkeypress = function(){CAT_STOCKFLOW_ID_TXT.onchange();};
			CAT_STOCKFLOW_ID_TXT.onpaste = function(){CAT_STOCKFLOW_ID_TXT.onchange();};
			//CAT_STOCKFLOW_ID_TXT.oninput = function(){CAT_STOCKFLOW_ID_TXT.onchange();};
		}
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("CAT_STOCKFLOW_DESCRIPTION_TXT"))
		{
			CAT_STOCKFLOW_DESCRIPTION_TXT = JSOC_ELEMENT.VAR_GET("CAT_STOCKFLOW_DESCRIPTION_TXT");      
			CAT_STOCKFLOW_DESCRIPTION_TXT.onchange = 
				function()
				{
					if(CAT_STOCKFLOW_DESCRIPTION_TXT.disabled == false)
					{
						EDIT_HANDLER.REF_IS_MODIFIED = true;
					}
				};
			CAT_STOCKFLOW_DESCRIPTION_TXT.onkeypress = function(){CAT_STOCKFLOW_DESCRIPTION_TXT.onchange();};
			CAT_STOCKFLOW_DESCRIPTION_TXT.onpaste = function(){CAT_STOCKFLOW_DESCRIPTION_TXT.onchange();};
			//CAT_STOCKFLOW_DESCRIPTION_TXT.oninput = function(){CAT_STOCKFLOW_DESCRIPTION_TXT.onchange();};
		}
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("CAT_STOCKFLOW_IS_IN_CMB"))
		{
			CAT_STOCKFLOW_IS_IN_CMB = JSOC_ELEMENT.VAR_GET("CAT_STOCKFLOW_IS_IN_CMB");     
			CAT_STOCKFLOW_IS_IN_CMB.onchange = 
				function()
				{
					if(CAT_STOCKFLOW_IS_IN_CMB.disabled == false)
					{
						EDIT_HANDLER.REF_IS_MODIFIED = true;
					}
				};
			CAT_STOCKFLOW_IS_IN_CMB.onkeypress = function(){CAT_STOCKFLOW_IS_IN_CMB.onchange();};
			CAT_STOCKFLOW_IS_IN_CMB.onpaste = function(){CAT_STOCKFLOW_IS_IN_CMB.onchange();};
			//CAT_STOCKFLOW_IS_IN_CMB.oninput = function(){CAT_STOCKFLOW_IS_IN_CMB.onchange();};						
		}
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("CAT_STOCKFLOW_IS_MONITORED_TXT"))
		{
			CAT_STOCKFLOW_IS_MONITORED_TXT = JSOC_ELEMENT.VAR_GET("CAT_STOCKFLOW_IS_MONITORED_TXT");      
			CAT_STOCKFLOW_IS_MONITORED_TXT.onchange = 
				function()
				{
					if(CAT_STOCKFLOW_IS_MONITORED_TXT.disabled == false)
					{
						EDIT_HANDLER.REF_IS_MODIFIED = true;
					}
				};
			CAT_STOCKFLOW_IS_MONITORED_TXT.onkeypress = function(){CAT_STOCKFLOW_IS_MONITORED_TXT.onchange();};
			CAT_STOCKFLOW_IS_MONITORED_TXT.onpaste = function(){CAT_STOCKFLOW_IS_MONITORED_TXT.onchange();};
			//CAT_STOCKFLOW_IS_MONITORED_TXT.oninput = function(){CAT_STOCKFLOW_IS_MONITORED_TXT.onchange();};
		}
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("CAT_STOCKFLOW_STATUS_CMB"))
		{
			CAT_STOCKFLOW_STATUS_CMB = JSOC_ELEMENT.VAR_GET("CAT_STOCKFLOW_STATUS_CMB");      	
			CAT_STOCKFLOW_STATUS_CMB.onchange = 
				function()
				{
					if(CAT_STOCKFLOW_STATUS_CMB.disabled == false)
					{
						EDIT_HANDLER.REF_IS_MODIFIED = true;
					}
				};
			CAT_STOCKFLOW_STATUS_CMB.onkeypress = function(){CAT_STOCKFLOW_STATUS_CMB.onchange();};
			CAT_STOCKFLOW_STATUS_CMB.onpaste = function(){CAT_STOCKFLOW_STATUS_CMB.onchange();};
			//CAT_STOCKFLOW_STATUS_CMB.oninput = function(){CAT_STOCKFLOW_STATUS_CMB.onchange();};							
		}
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("CAT_STOCKFLOW_SYSTEM_GENERATED_TXT"))
		{
			CAT_STOCKFLOW_SYSTEM_GENERATED_TXT = JSOC_ELEMENT.VAR_GET("CAT_STOCKFLOW_SYSTEM_GENERATED_TXT");      
			CAT_STOCKFLOW_SYSTEM_GENERATED_TXT.onchange = 
				function()
				{
					if(CAT_STOCKFLOW_SYSTEM_GENERATED_TXT.disabled == false)
					{
						EDIT_HANDLER.REF_IS_MODIFIED = true;
					}
				};
			CAT_STOCKFLOW_SYSTEM_GENERATED_TXT.onkeypress = function(){CAT_STOCKFLOW_SYSTEM_GENERATED_TXT.onchange();};
			CAT_STOCKFLOW_SYSTEM_GENERATED_TXT.onpaste = function(){CAT_STOCKFLOW_SYSTEM_GENERATED_TXT.onchange();};
			//CAT_STOCKFLOW_SYSTEM_GENERATED_TXT.oninput = function(){CAT_STOCKFLOW_SYSTEM_GENERATED_TXT.onchange();};
		}
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("PARAM_CAT_STOCKFLOW_ID_FILE_FP"))
		{
			PARAM_CAT_STOCKFLOW_ID_FILE_FP = JSOC_ELEMENT.VAR_GET("PARAM_CAT_STOCKFLOW_ID_FILE_FP");
			PARAM_CAT_STOCKFLOW_ID_FILE_FP.onchange = 
				function()
				{
					if(PARAM_CAT_STOCKFLOW_ID_FILE_FP.disabled == false)
					{
						EDIT_HANDLER.REF_IS_MODIFIED = true;
					}
				};			
		}
				
		
		// Initialize: Default Settings
		// ...........................................
		// FORM_PREPARE_DEFAULT_SETTINGS();   	
	};